From 876764b2114d86a45520b0e0a9e8351658dba2a7 Mon Sep 17 00:00:00 2001
From: Osamu Aoki <osamu@debian.org>
Date: Thu, 27 Aug 2015 22:35:38 +0900
Subject: [PATCH 1/2] pagemangle-test

---
 scripts/uscan.pl | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

diff --git a/scripts/uscan.pl b/scripts/uscan.pl
index ef21e2c..27f56ce 100755
--- a/scripts/uscan.pl
+++ b/scripts/uscan.pl
@@ -822,6 +822,9 @@ sub process_watchline ($$$$$$)
 		    @{$options{'uversionmangle'}} = split /;/, $1;
 		    @{$options{'dversionmangle'}} = split /;/, $1;
 		}
+		elsif ($opt =~ /^pagemangle\s*=\s*(.+)/) {
+		    @{$options{'^pagemangle'}} = split /;/, $1;
+		}
 		elsif ($opt =~ /^filenamemangle\s*=\s*(.+)/) {
 		    @{$options{'filenamemangle'}} = split /;/, $1;
 		}
@@ -997,6 +1000,18 @@ sub process_watchline ($$$$$$)
 	print STDERR "$progname debug: received content:\n$content\[End of received content]\n"
 	    if $debug;
 
+	# pagenmangle: should not abuse this slow operation
+	foreach my $pat (@{$options{'pagemangle'}}) {
+	    if (! safe_replace(\$content, $pat)) {
+		uscan_warn "$progname: In $watchfile, potentially"
+		  . " unsafe or malformed pagemangle"
+		  . " pattern:\n  '$pat'"
+		  . " found. Skipping watchline\n"
+		  . "  $line\n";
+		return 1;
+	    }
+	}
+
 	if ($content =~ m%^<[?]xml%i &&
 	    $content =~ m%xmlns="http://s3.amazonaws.com/doc/2006-03-01/"%) {
 	    # this is an S3 bucket listing.  Insert an 'a href' tag
-- 
2.1.4

